<?
/******************************************************************************
Epiware: Project and Document Management
http://www.epiware.com
Copyright (C) 2006 James Kern

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version. 

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details. 

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

Epiware, Inc. and Praxis Inc, hereby disclaims all copyright
interest in the program 'Epiware' written
by James Kern, Edward Kline, Ryan Gilfether, Ray Gorospe, Patrick Waddingham

06 September 2006
James Kern, President of Epiware 
Jack Chapman, President of Praxis
*****************************************************************************/ 
/**
*	@package conferences
*/
class DB
{
   //----------------------------------------------------------
   // This is private variable used to hold the connection id
   //----------------------------------------------------------
	var $connect = 0;
	var $debug = 0;
	var $is_connect_err = 0;
	var $last_id = 0;
	var $replaceQuote = "\\'"; 	// string to use to replace quotes
	var $date_handler;
	var $time_handler;
	var $last_message;
   //-------------------------------------------------------------------
   // This will make a connection when the object declared in the front
   //-------------------------------------------------------------------
   function DB($db_name=DB_NAME,$username=USERNAME,$password=PASSWORD,$ip_address=IP_ADDRESS,$new_connection=false)
   {
		$this->date_handler = new date_handler();
		$this->time_handler = new time_handler();
      //This supresses all warining messages that are sent to the screen
		//if(!(SHOW_ERROR == 1))
		//{
		  //error_reporting(0);
		//}

      //-------------------------------------------------------------------
      // Do the connect--Must have this no matter what mode I am running in
      //-------------------------------------------------------------------

		$error = 0;
		$reason = "";

		//must pass true to open a new connection.. otherwise having more than one connection on a page.. is not having more than one connection
		//but rather reopening an existing connection
		$this->connect = mysql_connect($ip_address,$username,$password,$new_connection);

		if($this->connect)
		{
			if(!mysql_select_db($db_name))
			{
				$reason = "<font size=+2 face=\"ariral,verdana,hlvetica\" color=aa0000> "
				. " Unable to connect to database \"$db_name\""
				. "</font>";

				$this->is_connect_err = 1;
				print "$reason" . "<BR><BR>";
				print "<font face='arial,verdana' size=+1>";
				print "<ol>";
				print "<li>Check to see if Mysql is running" . "<BR>";
				print "<li>Make sure the Database \"" . $db_name . "\" exists"  . "<BR>"; 
				print "<li>The Database \"" . $db_name . "\" is defined in file config.inc.php" . "<BR>"; 
				print "<li>Make sure the USERNAME defined in the config.inc.php can connect to the Database \"" . $db_name . "\""  . "<BR>"; 
				print "<li>You Can create the Database \"" . $db_name . "\" using file project_db.sql"  . "<BR>"; 
				print "example: mysql -uroot -p < project_db.sql  ";
				print "</ol>";
				print "</font>";
				exit; 
			}
			else
			{
				$this->is_connect_err = 0;
				$this->database = $db_name;
				return true;
			}
		}
		else
		{
			$reason = "<font size=+2 face=\"ariral,verdana,hlvetica\" color=aa0000><B>Unable to connect to database</b></font>";

			$this->is_connect_err = 1;
			print "$reason";
		}
		return false;
   }  //END OF FUNCTION DB

	/**
	 * Converts a timestamp "ts" to a string that the database can understand.
	 * An example is  $db->qstr("Don't bother",magic_quotes_runtime());
	 *
	 * @param s			the string to quote
	 * @param [magic_quotes]	if $s is GET/POST var, set to get_magic_quotes_gpc().
	 *				This undoes the stupidity of magic quotes for GPC.
	 *
	 * @return  quoted string to be sent back to database
	 */
	function qstr($s,$magic_quotes=false)
	{
		$nofixquotes=false;
		if (!$magic_quotes)
		{
			return  "'".str_replace("'",$this->replaceQuote,$s)."'";
		}

		// undo magic quotes for "
		$s = str_replace('\\"','"',$s);

		if ($this->replaceQuote == "\\'")  // ' already quoted, no need to change anything
		{
			return "'$s'";
		}
		else
		{// change \' to '' for sybase/mssql
			$s = str_replace('\\\\','\\',$s);
			return "'".str_replace("\\'",$this->replaceQuote,$s)."'";
		}
	}//end of function qstr

	/* Returns the number of rows in a result
	*
	*	@param	resource $result db result set
	*	return integer	-1 if error otherwise num rows in result set
	*/
    function row_count($result)
    {
       $answer = -1;
	   if(is_resource($result))
		{
            $answer = mysql_num_rows($result);
		}
		return $answer;
    }//end of row_count


	 function get_server_version()
	 {
	  	return (mysql_get_server_info($this->connect));
	 }


   function get_error()
   {
                //Added 06-13-2001 by Edward Kline
                //%precondition : must be called immediately following the sql statement with an error
					 //%precondition : must use resource identifier
					 //%return : an error object with properties: number,message

                $answer->number = mysql_errno($this->connect);
                $answer->message = mysql_error($this->connect);

                return $answer;
   }

   function get_next_id($table_name)
	{
	   //requires that _inc tables be in use
		$inc_table = $table_name . "_inc";
		$sql_lock = "lock tables $inc_table write";
      $sql_unlock = "unlock tables";
		$the_id = -1;
		if($this->perform_action_query($sql_lock))
		{
		 	$sql = "select inc from $inc_table";
			if($result = $this->perform_looping_query($sql))
			{
				if($row = $this->get_next_row($result,MYSQL_ASSOC))
				{
				 	if($row["inc"] == "")
					{
					 	$the_id = 1;
						$sql = "insert into $inc_table (inc) values (2)";
						$this->perform_action_query($sql);
					}
					else if($row["inc"]==0)
					{
					 	$the_id = 1;
						$sql = "update $inc_table set inc=2";
						$this->perform_action_query($sql);
					}
					else
					{
						$the_id = $row["inc"];
						$sql = "update $inc_table set inc=inc+1";
						$this->perform_action_query($sql);
					}
				}//end of if row
				else
				{
					$the_id = 1;
					$sql = "insert into $inc_table (inc) values (2)";
					$this->perform_action_query($sql);
				}
				$this->free_result_set($result);
			}
			$this->perform_action_query($sql_unlock);
		}//end of if lock obtained
		$this->last_id = $the_id;
		return $the_id;
	}//end of get next id

	function get_next_complex_id($prop_array,$table_name)
	{
	   //requires that increment tables be in use
		//$prop_array must be an array indexed by field_name w/value = integer value
		if(is_array($prop_array))
		{
			while(list($k,$v)=each($prop_array))
			{
			 	$where_str[] = " $k=$v ";
				$field_str[] = $k;
				$val_str[] = $v;

			}

			$where = implode("and",$where_str);
			$fields = implode(",",$field_str);
			$values = implode(",",$val_str);
		}
		$inc_table = $table_name . "_inc";
		$sql_lock = "lock tables $inc_table write";
      $sql_unlock = "unlock tables";
		$the_id = -1;
		if($this->perform_action_query($sql_lock))
		{
		 	$sql = "select inc from $inc_table where $where";
			if($result = $this->perform_looping_query($sql))
			{
				if($row = $this->get_next_row($result,MYSQL_ASSOC))
				{
				 	if($row["inc"] == "")
					{
					 	$the_id = 1;
						$sql = "insert into $inc_table (inc,$fields) values (2,$values)";
						$this->perform_action_query($sql);
					}
					else if($row["inc"]==0)
					{
					 	$the_id = 1;
						$sql = "update $inc_table set inc=2 where $where";
						$this->perform_action_query($sql);
					}
					else
					{
						$the_id = $row["inc"];
						$sql = "update $inc_table set inc=inc+1 where $where";
						$this->perform_action_query($sql);
					}
				}//end of if row
				else
				{
					$the_id = 1;
					$sql = "insert into $inc_table (inc,$fields) values (2,$values)";
					$this->perform_action_query($sql);
				}
				$this->free_result_set($result);
			}
			$this->perform_action_query($sql_unlock);
		}//end of if lock obtained
		$this->last_id = $the_id;
		return $the_id;
	}//end of get next id

   function disconnect_db()
   {
     $status =  mysql_close($this->connect);
   } // END OF FUNCTION DISCONNECT_DB



   function &perform_looping_query($sql)
   {
	   global $user_id;

      $result = @mysql_query($sql,$this->connect);

		if(!$result)
		{

		}
		else
		{
			$status = 1;
		}

		if($this->debug == 1)
		{
		 	$this->send_info_to_screen($sql);
		}
       return $result;
   } // END OF FUNCTION PERFORM_LOOPING_QUERY


	function data_seek(&$result,$position)
    {
	 	if(is_resource($result))
		{
          mysql_data_seek($result,$position);
		}
    }


   function &get_next_row(&$result,$result_type=MYSQL_BOTH)
   {
		if(is_resource($result))
		{
			if(!($row = mysql_fetch_array($result,$result_type)))
			{
		 	$row = 0;
			}
       		return $row;
		}
		return false;
   } // END OF FUNCTION GET_NEXT_ROW

   function get_next_object(&$result)
   {
		if(is_resource($result))
		{
       			$row = mysql_fetch_object($result);
			if(is_array($row))
			{
			        while(list($k,$v)=each($row))
			        {
			                $obj->{$k} = $v;
			        }
			        return $obj;
			}
			else
			{
				return $row;
			}
		}
		else
		{
		 	return false;
		}
   } // END OF FUNCTION GET_NEXT_ROW



   function free_result_set(&$result)
   {
	   if(is_resource($result))
	   {
			mysql_free_result($result);
	   }
   } // END OF FUNCTION FREE_RESULT_SET



   function perform_action_query($sql)
   {
      $result = @mysql_query($sql,$this->connect);


      if(!$result)
		{
		   $status = 0;
		}
		else
		{
		   $status = 1;
		}

		if($this->debug == 1)
		{
			$this->send_info_to_screen($sql);
		}

      // Can decide what to do in the application if I see failure or success
      return $status;
   } // END OF FUNCTION PERFORM_ACTION_QUERY


   function get_last_id()
	{
		//must use the resource identifier... because if you do not
		//then on pages with multiple connections... this function does
		//not work properly
		 $id = mysql_insert_id($this->connect);
       $this->last_id = $id;
       return $id;
   }

	/**
	*	Turn on or off debug mode
	*	@param	boolean	$on	default on, false turns off debug mode
	*/
	function debug($on=true)
	{
		$this->debug = $on?1:0;
	}

	/**
	*	Turn on or off debug mode
	*	@param	boolean	$on	default on, false turns off debug mode
	*/
	function debug_sql($on=true)
	{
		$this->debug = $on?1:0;
	}
   /**
	*	flush debug messages to stdout and clear buffer and optionally turn off debug
	*	@param	boolean	$off	true turns debug mode off; default true
	*/
	function flush_debug($off=true)
	{
		print $this->last_message;
		$this->last_message = "";
		if($off)
		{
			$this->debug = 0;
		}
	}//end of flush debug

   function send_info_to_screen($sql)
   {
		if($this->js_debug == 1)
		{
			$this->send_info_for_js($sql);
		}
		else
		{
			$output = "<br/><font face=helvetica color=990000>";
			$output.= $sql . "<br/>" ;
			$error_msg = @mysql_error($this->connect);
			$error_num = @mysql_errno($this->connect);
			if($error_num != 0)
			{
			$output.= "$error_num - $error_msg<BR>";
			}
			$output.= "</font>";
		}
		if(defined("FMS_DEV"))
		{
			trigger_error($output,FMS_DEV);
		}//end of if we are using FMS
		else
		{
		    $this->last_message .= $output;
			print $output;
		}
   }//end of send_info_to_screen

   function send_info_for_js($sql)
   {
		$output = $sql."\n\n";
        $error_msg = @mysql_error($this->connect);
        $error_num = @mysql_errno($this->connect);
        if($error_num != 0)
		{
           	$output.= "$error_num - $error_msg\n";
        }
        $output = htmlentities($output,ENT_NOQUOTES,"UTF-8");

		if(defined("FMS_DEV"))
		{
			trigger_error($output,FMS_DEV);
		}//end of if we are using FMS
		else
		{
		    $this->last_message .= $output;
			print $output;
		}
   }//end of send_info_to_screen


        //inserted on 05/30/2001 by Ed Kline
        function get_field_list($table_name)
        {
                //%precondition : $table_name ~ name of table in db
                 //%return : array of objects with properties: name,type,len,and flags or false
                //%- : corresponding to the those properties of the fields

                if($fields = mysql_list_fields($this->database,$table_name))
                {
                        $columns = mysql_num_fields($fields);

					for ($i = 0; $i < $columns; $i++)
                    {
								$answer[$i]->name = mysql_field_name($fields,$i);
                                $answer[$i]->type = mysql_field_type($fields,$i);
                                $answer[$i]->len = mysql_field_len($fields,$i);
                                $answer[$i]->flags = mysql_field_flags($fields,$i);
					}
                        return $answer;
                }
                else
                {
                         return false;
                }
        }

	function get_table_list()
	{
		if($tables = mysql_list_tables($this->database))
		{
			$i = 0;
			while($row = mysql_fetch_array($tables))
			{
				$answer[$i] = $row;
				$i++;
			}
			$this->free_result_set($tables);
			return $answer;
		}
		else
		{
			return false;
		}

	}

}  // END OF CLASS DB



/**
*	@package conferences
*/
class date_handler
{
    /*
    System date format is the unix timestamp format
    */
    var $year;
    var $month;
    var $day;
    var $systemDate;
    var $dbDate;

    function date_handler()
    {
       $this->year = date("Y");
       $this->month = date("m");
       $this->day = date("d");
       $this->systemDate = mktime(0,0,0,$this->month,$this->day,$this->year);
       $this->dbDate= "";
    }

    function db2system($dbDate,$dbType="mysql")
    {
		$temp = $dbDate + 0;
		//check to see if it is already an integer
		if(is_numeric($dbDate) &&  $temp > 0)
		{
			$this->dbDate = date("Y-m-d",$temp);
			$this->year = substr($this->dbDate,0,4);
			$this->month = substr($this->dbDate,5,2);
			$this->day = substr($this->dbDate,8,2);
			$this->systemDate = $temp;

			return $temp;
		}//end of if it was an integer

	   $this->year = substr($dbDate,0,4);
	   $this->month = substr($dbDate,5,2);
	   $this->day = substr($dbDate,8,2);
	   $date = mktime(0,0,0,$this->month,$this->day,$this->year);
	   $this->systemDate = $date;
	   $this->dbDate = $dbDate;
       return ($this->systemDate);
    }//end of db2system

    function system2db($sysDate,$dbType="mysql")
    {
		if(ereg("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})",$sysDate,$matches))
		{
			$this->dbDate = $sysDate;
			$this->systemDate = $this->db2system($sysDate);

			return($this->dbDate);
		}//end of if it is already in mysql format

		//make sure value is an int
		$sysDate +=0;
		$this->dbDate = date("Y-m-d",$sysDate);
		$this->systemDate = $sysDate;
	    $this->year = substr($this->dbDate,0,4);
		$this->month = substr($this->dbDate,5,2);
		$this->day = substr($this->dbDate,8,2);

		return ($this->dbDate);
    }//end of system2db



}//end of class date_handler

/**
*	@package conferences
*/
class time_handler
{
	/*
	System date format is the unix timestamp format
    */
    var $year;
    var $month;
    var $day;
	 var $hour;
	 var $minute;
	 var $second;

    var $systemDate;
    var $dbDate;

    function time_handler()
    {
			$this->systemDate = mktime();
			$dbDate = date("Y-m-d H:i:s",$this->systemDate);
			$this->dbDate = $dbDate;


			$this->year = substr($dbDate,0,4);
			$this->month = substr($dbDate,5,2);
			$this->day = substr($dbDate,8,2);
			$this->hour = substr($dbDate,11,2);
			$this->minute = substr($dbDate,14,2);
			$this->second = substr($dbDate,17,2);
    }

    function db2system($dbDate,$dbType="mysql")
    {
		$temp = $dbDate+0;
		if( is_numeric($dbDate) && $temp > 0)
		{
			$this->systemDate = $temp;
			$this->dbDate = date("Y-m-d H:i:s",$temp);

			$this->year = substr($this->dbDate,0,4);
			$this->month = substr($this->dbDate,5,2);
			$this->day = substr($this->dbDate,8,2);
			$this->hour = substr($this->dbDate,11,2);
			$this->minute = substr($this->dbDate,14,2);
			$this->second = substr($this->dbDate,17,2);
			return $temp;
		}//end of if it already is a timestamp

		//YYYY-MM-DD HH:MM:SS
		$this->year = substr($dbDate,0,4);
		$this->month = substr($dbDate,5,2);
		$this->day = substr($dbDate,8,2);
		$this->hour = substr($dbDate,11,2);
		$this->minute = substr($dbDate,14,2);
		$this->second = substr($dbDate,17,2);

		$this->systemDate = mktime($this->hour,$this->minute,$this->second,$this->month,$this->day,$this->year);
		$this->dbDate = $dbDate;

		return ($this->systemDate);
    }//end of db2system

    function system2db($sysDate,$dbType="mysql")
    {
		if(ereg("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{2}):([0-9]{2})",$sysDate,$matches))
		{
			$this->dbDate = $sysDate;
			$this->systemDate = $this->db2system($sysDate);

			return($this->dbDate);
		}//end of if it is already in mysql format

		//YYYY-MM-DD HH:MM:SS
		//make sure sysDate is integer
		$sysDate += 0;
		$this->dbDate = date("Y-m-d H:i:s",$sysDate);
		$this->systemDate = $sysDate;

		$this->year = substr($this->dbDate,0,4);
		$this->month = substr($this->dbDate,5,2);
		$this->day = substr($this->dbDate,8,2);
		$this->hour = substr($this->dbDate,11,2);
		$this->minute = substr($this->dbDate,14,2);
		$this->second = substr($this->dbDate,17,2);

		return ($this->dbDate);
    }//end of system2db
}//end of time_handler

/**
*	Returns object from select query
*	@param	resource	$result		database result
*	@param	boolean		$free	optional true or false if the function should free the result set; default is false
*	@return	object	object from result or false
*/
function return_object(&$result,$free=false)
{
	$answer = false;
	if(is_resource($result))
	{
		$answer = DB::get_next_object($result);
		if($free)
		{
			DB::free_result_set($result);
		}
	}
	return $answer;
}//end of return_object

/**
*	Returns array of objects from select query
*	@param	resource	$result		database result
*	@param	boolean		$free	optional true or false if the function should free the result set; default is false
*	@return	array	array of object from result or false
*/
function return_all_objects(&$result,$free=false)
{
	$answer = false;
	if(is_resource($result))
	{
		while($obj = DB::get_next_object($result))
		{
			$answer[] = $obj;
		}
		if($free)
		{
			DB::free_result_set($result);
		}
	}
	return $answer;
}//end of return_all_objects

function build_insert_sql($names,$values,$table_name)
{
                $sql = "INSERT into ".$table_name." (";

                $count = count($names);

                $sql.= $names[0];
                $sql_vals = "'".$values[0]."'";

                for($i=1;$i<$count;$i++)
                {
                        $sql.= ",".$names[$i];
                        $sql_vals.= ",'".$values[$i]."'";
                }
                $sql .= ") VALUES (".$sql_vals.")";

                return $sql;
}

function build_update_sql($names,$values,$table_name,$where="")
{
                $sql = "UPDATE ".$table_name." SET ";

                $count = count($names);

                $sql.= $names[0]."='".$values[0]."'";

                $count = count($names);
                for($i=1;$i<$count;$i++)
                {
                        $sql .= ",".$names[$i]."='".$values[$i]."'";
                }

                if($where!="")
                        $sql .= " WHERE ".$where;

                return $sql;
}

function build_select_sql($names,$table_name,$orderby="",$where="")
{
                $sql = "SELECT ";
                $sql .= $names[0];

                $count = count($names);
                for($i=1;$i<$count;$i++)
                {
                        $sql .= ",".$names[$i];
                }

                $sql .= " FROM ".$table_name;

                if($where != "")
                        $sql .= " WHERE ".$where;

                if($orderby != "")
                        $sql .= " ORDER BY ".$orderby;

                return $sql;
}

function build_delete_sql($table_name,$where)
{
        $sql = "DELETE FROM ".$table_name." WHERE ".$where;
        return $sql;
}


//define function to print to screen from db
function print_from_db($string)
{
        if($string=="")
        {
                print "&nbsp;";
        }
        else
        {
                print htmlspecialchars($string);
        }
}//end of print from db
?>